/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
import type { AddressInfo } from 'net';
import type { AstroSettings, AstroUserConfig } from '../../@types/astro';
import * as http from 'http';
import { LogOptions } from '../logger/core.js';
import nodeFs from 'fs';
import * as vite from 'vite';
export interface Container {
    fs: typeof nodeFs;
    logging: LogOptions;
    settings: AstroSettings;
    viteConfig: vite.InlineConfig;
    viteServer: vite.ViteDevServer;
    handle: (req: http.IncomingMessage, res: http.ServerResponse) => void;
    close: () => Promise<void>;
}
export interface CreateContainerParams {
    isRestart?: boolean;
    logging?: LogOptions;
    userConfig?: AstroUserConfig;
    settings?: AstroSettings;
    fs?: typeof nodeFs;
    root?: string | URL;
}
export declare function createContainer(params?: CreateContainerParams): Promise<Container>;
export declare function startContainer({ settings, viteServer, logging }: Container): Promise<AddressInfo>;
export declare function runInContainer(params: CreateContainerParams, callback: (container: Container) => Promise<void> | void): Promise<void>;
