import notFoundTemplate, { subpathNotUsedTemplate } from "../template/4xx.js";
import { log404 } from "./common.js";
import { writeHtmlResponse } from "./response.js";
function baseMiddleware(settings, logging) {
  const { config } = settings;
  const site = config.site ? new URL(config.base, config.site) : void 0;
  const devRoot = site ? site.pathname : "/";
  return function devBaseMiddleware(req, res, next) {
    var _a;
    const url = req.url;
    const pathname = decodeURI(new URL(url, "http://vitejs.dev").pathname);
    if (pathname.startsWith(devRoot)) {
      req.url = url.replace(devRoot, "/");
      return next();
    }
    if (pathname === "/" || pathname === "/index.html") {
      log404(logging, pathname);
      const html = subpathNotUsedTemplate(devRoot, pathname);
      return writeHtmlResponse(res, 404, html);
    }
    if ((_a = req.headers.accept) == null ? void 0 : _a.includes("text/html")) {
      log404(logging, pathname);
      const html = notFoundTemplate({
        statusCode: 404,
        title: "Not found",
        tabTitle: "404: Not Found",
        pathname
      });
      return writeHtmlResponse(res, 404, html);
    }
    next();
  };
}
export {
  baseMiddleware
};
