import nodeFs from "fs";
function loadFallbackPlugin({ fs }) {
  if (!fs || fs === nodeFs) {
    return false;
  }
  return {
    name: "astro:load-fallback",
    enforce: "post",
    async load(id) {
      try {
        return await fs.promises.readFile(cleanUrl(id), "utf-8");
      } catch (e) {
        try {
          return await fs.promises.readFile(id, "utf-8");
        } catch (e2) {
        }
      }
    }
  };
}
const queryRE = /\?.*$/s;
const hashRE = /#.*$/s;
const cleanUrl = (url) => url.replace(hashRE, "").replace(queryRE, "");
export {
  loadFallbackPlugin as default
};
